	.ORIG x200
	LEA R0, INPUT_ARRAY
	JSR BUILD_MAX_HEAP
	CONST R1, 1
	LDR R2, R0, 0
	ST R2, ARRAY_LENGTH
HEAP_SORT_LOOP
	SUB R3, R2, R1
	BRz R3, HEAP_SORT_DONE
	ADD R4, R0, R1	;R4 = ADDR(A[1])
	LDR R5, R4, 0	;R5 = A[1]
	ADD R6, R0, R2	;R6 = ADDR(A[i])
	LDR R7, R6, 0	;R7 = A[i]
	STR R7, R4, 0
	STR R5, R6, 0
	LDR R5, R0, 0
	INC R5, -1
	STR R5, R0, 0
	JSR MAX_HEAPIFY
	INC R2, -1
	JUMP HEAP_SORT_LOOP
HEAP_SORT_DONE
	LD R2, ARRAY_LENGTH
	STR R2, R0, 0	
	HALT

ARRAY_LENGTH
	.BLKW 1

INPUT_ARRAY
	.FILL 20
	.FILL 4
	.FILL 1
	.FILL 20
	.FILL 3
	.FILL 2
	.FILL 16
	.FILL 9
	.FILL 10
	.FILL 14
	.FILL 8
	.FILL 7
	.FILL 17
	.FILL 12
	.FILL 13
	.FILL 5
	.FILL 19
	.FILL 6
	.FILL 15
	.FILL 18
	.FILL 11
	
	 

;R0 = A
BUILD_MAX_HEAP
	;SAVE THE REGISTERS TO THE STACK
	ST R7, TEMP_SAVE_R7
	LD R7, TOS
	INC R7, -8
	ST R7, TOS
	STR R6, R7, 2
	STR R5, R7, 3
	STR R4, R7, 4
	STR R3, R7, 5
	STR R2, R7, 6
	STR R1, R7, 7
	STR R0, R7, 8
	LD R6, TEMP_SAVE_R7
	STR R6, R7, 1		

	LDR R1, R0, 0
	CONST R2, 1
	SRL R1, R1, R2
BMH_LOOP
	BRz R1, BMH_RESTORE
	JSR MAX_HEAPIFY
	INC R1, -1
	JUMP BMH_LOOP
BMH_RESTORE
	;RESTORE REGISTERS FROM THE STACK
	LD R7, TOS
	INC R7, 8
	ST R7, TOS
	LDR R0, R7, 0
	LDR R1, R7, -1
	LDR R2, R7, -2
	LDR R3, R7, -3
	LDR R4, R7, -4
	LDR R5, R7, -5
	LDR R6, R7, -6
	LDR R7, R7, -7
	JUMPR R7	;RET


;R0 = A
;R1 = i
MAX_HEAPIFY
	;SAVE REGISTERS TO THE STACK
	ST R7, TEMP_SAVE_R7
	LD R7, TOS
	INC R7, -8
	ST R7, TOS
	STR R6, R7, 2
	STR R5, R7, 3
	STR R4, R7, 4
	STR R3, R7, 5
	STR R2, R7, 6
	STR R1, R7, 7
	STR R0, R7, 8
	LD R6, TEMP_SAVE_R7
	STR R6, R7, 1
	

	LDR R2, R0, 0	;R2 = ARRAY LENGTH
	CONST R5, 1
	SLL R3, R1, R5	;R3 = INDEX OF LEFT CHILD = 2i
	SLL R4, R1, R5
	INC R4, 1	;R4 = INDEX OF RIGHT CHILD = 2i + 1
	CONST R5, 0
	ADD R5, R5, R1	;R5 = INDEX OF LARGEST ELEMENT BEING CONSIDERED (INITIALLY i)
CHECK_LEFT
	SUB R6, R3, R2
	BRp R6, MH_RESTORE	;IF LEFT > ARRAY_LENGTH, DO NOTHING
	ADD R6, R0, R3
	LDR R6, R6, 0	;R6 = A[LEFT]
	ADD R7, R0, R1
	LDR R7, R7, 0	;R7 = A[i]
	SUB R7, R6, R7
	BRnz R7, CHECK_RIGHT	;IF A[LEFT] <= A[i], DON'T UPDATE THE LARGEST INDEX
	CONST R5, 0
	ADD R5, R5, R3		;ELSE, SET LARGEST TO LEFT
CHECK_RIGHT
	SUB R6, R4, R2
	BRp R6, MH_SWAP	;IF RIGHT > ARRAY_LENGTH, IGNORE IT
	ADD R6, R0, R4
	LDR R6, R6, 0	;R6 = A[RIGHT]
	ADD R7, R0, R5
	LDR R7, R7, 0	;R7 = A[LARGEST]
	SUB R7, R6, R7
	BRnz R7, MH_SWAP	;IF A[RIGHT] > A[LARGEST], SET THE LARGEST INDEX TO RIGHT
	CONST R5, 0
	ADD R5, R5, R4
MH_SWAP
	SUB R2, R1, R5
	BRz R2, MH_RESTORE	;IF i != LARGERST, SWAP A[LARGEST] AND A[i]
	ADD R6, R0, R1	;R6 = ADDR(A[i])
	LDR R7, R6, 0	;R7 = A[i]
	ADD R2, R0, R5	;R2 = ADDR(A[LARGEST])
	LDR R3, R2, 0	;R3 = A[LARGEST]
	STR R3, R6, 0
	STR R7, R2, 0
	CONST R1, 0
	ADD R1, R5, R1	;SET R1 TO LARGEST FOR RECURSIVE CALL
	JSR MAX_HEAPIFY
MH_RESTORE
	;RESTORE REGISTERS FROM THE STACK
	LD R7, TOS
	INC R7, 8
	ST R7, TOS
	LDR R0, R7, 0
	LDR R1, R7, -1
	LDR R2, R7, -2
	LDR R3, R7, -3
	LDR R4, R7, -4
	LDR R5, R7, -5
	LDR R6, R7, -6
	LDR R7, R7, -7
	JUMPR R7	;RET

TEMP_SAVE_R7
	.BLKW 1
TOS
	.FILL xBFFF
