;This program performs scaled vector addition
;(Z = AX + BY)
;It would take as inputs addresses of the 3 vectors,
;the vector length, and the 2 scaling constants.
;
;This program has the same functionality as scaled_vect_add_v1,
;but it is written differently.  Do you think either version is
;better in regard to performance?

	.ORIG x200
	LEA R0, VECT_X
	LEA R1, VECT_Y
	LEA R2, VECT_Z
	CONST R3, 0
	LD R6, VECT_LENGTH

SCALED_VECT_ADD_LOOP
	SUB R4, R6, R3
	BRz R4, SCALED_VECT_ADD_DONE
	ADD R4, R0, R3
	LDR R4, R4, 0
	LD R7, A
	MUL R4, R4, R7
	ADD R5, R1, R3
	LDR R5, R5, 0
	LD R7, B
	MUL R5, R5, R7
	ADD R4, R4, R5
	ADD R5, R2, R3
	STR R4, R5, 0
	INC R3, 1
	JUMP SCALED_VECT_ADD_LOOP

SCALED_VECT_ADD_DONE
	HALT

VECT_X
	.FILL 1
	.FILL 2
	.FILL 3
	.FILL 4
	.FILL 5
	.FILL 6
	.FILL 7
	.FILL 8
	.FILL 9
	.FILL 10

VECT_Y
	.FILL 11
	.FILL 12
	.FILL 13
	.FILL 14
	.FILL 15
	.FILL 16
	.FILL 17
	.FILL 18
	.FILL 19
	.FILL 20

VECT_Z
	.BLKW 10

A
	.FILL 2

B
	.FILL 3

VECT_LENGTH
	.FILL 10
	